#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve() {
    ll h, w, k, m;
    cin >> h >> w >> k >> m;

    ll a = 1, b = -k, c = (m - k - 1);

    ll D = b * b - 4 * a * c;

    auto x1 = (-b - sqrt(D)) / double(2 * a);
    auto x2 = (-b + sqrt(D)) / double(2 * a);
    ll fi = (b - sqrt(D)) / double(2 * a);
    ll se = (b + sqrt(D)) / double(2 * a);

    ll best = -1;

    auto relax = [&](ll x) {
        if (x >= 0 && x <= k && (x + 1) * (k - x + 1) == m && x < h && k - x < w) {
            if (best == -1 || best > x) {
                best = x;
            }
        }
    };

    for (ll x = fi - 1000; x <= fi + 1000; ++x) {
        relax(x);
        relax(k - x);
    }
    for (ll x = se - 1000; x <= se + 1000; ++x) {
        relax(x);
        relax(k - x);
    }

    if (best == -1) {
        cout << -1 << '\n';
        return;
    }

    cout << best << " " << k - best << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
