#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr ll lim = 3e10;

map<ll, ll> mp;

void solve() {
    ll n;
    cin >> n;

    cout << mp[n] << endl;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll x = 1, y = 1;
    while (true) {
        ll f = x + y;
        if (f >= lim) {
            break;
        }
        x = y;
        y = f;

        auto nxt = mp;
        nxt[f] += 1;
        for (auto [n, cnt] : mp) {
            ll v = f;
            while (lim / v >= n) {
                nxt[v * n] += cnt;
                if (lim / v < f) {
                    break;
                }
                v *= f;
            }
        }
        mp = nxt;
    }

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
