#include <bits/stdc++.h>

using namespace std;
using ll = long long;


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    ll p;
    cin >> n >> p;

    vector<ll> z(n), a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> z[i] >> a[i] >> b[i];
    }

    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return a[i] > a[j];
    });

    auto check = [&](ll mid) -> bool {
        ll have = 0;
        for (int i = 0; i < n; ++i) {
            have += a[i] * min(z[i], mid) + max(0ll, mid - z[i]) * b[i];
        }
        return have >= p;
    };

    ll lo = -1, hi = p;
    while (lo + 1 < hi) {
        ll mid = (lo + hi) / 2;
        if (check(mid)) {
            hi = mid;
        } else {
            lo = mid;
        }
    }

    cout << hi << '\n';

    return 0;
}
