#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int MOD = 1e9 + 7;

void add(int &x, int y) {
    if ((x += y) >= MOD) x -= MOD;
}

constexpr int K = 8;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);


    int n, m;
    cin >> n >> m;

    vector<int> a(m);
    for (int i = 0; i < m; ++i) {
        cin >> a[i];
        --a[i];
    }

    map<array<int, K>, int> dp;
    array<int, K> init{};
    iota(init.begin(), init.end(), 0);
    dp[init] = 1;

    for (int i = 0; i < n; ++i) {
        map<array<int, K>, int> nxt;
        for (auto &[b, cnt] : dp) {
            auto bb = b;
            for (int ii = 0; ii < K; ++ii) {
                bb[ii] = min(ii, bb[ii] + 1);
            }
            for (int x : a) {
                if (b[x] >= x) {
                    bb[x] = 0;
                    add(nxt[bb], cnt);
                    bb[x] = min(x, b[x] + 1);
                }
            }
        }
        swap(dp, nxt);
    }

    int ans = 0;
    for (auto [x, y] : dp) {
        add(ans, y);
    }

    cout << ans << '\n';

    return 0;
}
