#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<ll> fib;

void solve() {
    ll n;
    cin >> n;

    map<ll, ll> mp;
    mp[1] = 1;

    auto relax = [&](ll f) {
        auto nxt = mp;
        for (auto [x, cnt] : mp) {
            ll v = 1;
            while (true) {
                if (n / v < f) {
                    break;
                }
                v *= f;
                if (n % v) {
                    break;
                }
                if (n / v >= x && n % (v * x) == 0) {
                    nxt[x * v] += 1;
                }
            }
        }
        swap(mp, nxt);
    };

    for (ll f : fib) {
        relax(f);
    }

    cout << mp[n] << '\n';
}


int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll x = 1, y = 1;
    while (true) {
        ll f = x + y;
        if (f >= 1e18) {
            break;
        }
        fib.push_back(f);
        x = y;
        y = f;
    }

    int test = 1;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
